HDOJ 1240 Asteroids!

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1240

Asteroids!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 3643    Accepted Submission(s): 2413

Problem Description

You‘re in space.

You want to get home.

There are asteroids.

You don‘t want to hit them.

Input

Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the following description, and there will be no blank lines separating data sets.

A single data set has 5 components:

Start line - A single line, "START N", where 1 <= N <= 10.

Slice list - A series of N slices. Each slice is an N x N matrix representing a horizontal slice through the asteroid field. Each position in the matrix will be one of two values:

‘O‘ - (the letter "oh") Empty space

‘X‘ - (upper-case) Asteroid present

Starting Position - A single line, "A B C", denoting the <A,B,C> coordinates of your craft‘s starting position. The coordinate values will be integers separated by individual spaces.

Target Position - A single line, "D E F", denoting the <D,E,F> coordinates of your target‘s position. The coordinate values will be integers separated by individual spaces.

End line - A single line, "END"

The origin of the coordinate system is <0,0,0>. Therefore, each component of each coordinate vector will be an integer between 0 and N-1, inclusive.

The first coordinate in a set indicates the column. Left column = 0.

The second coordinate in a set indicates the row. Top row = 0.

The third coordinate in a set indicates the slice. First slice = 0.

Both the Starting Position and the Target Position will be in empty space.

Output

For each data set, there will be exactly one output set, and there will be no blank lines separating output sets.

A single output set consists of a single line. If a route exists, the line will be in the format "X Y", where X is the same as N from the corresponding input data set and Y is the least number of moves necessary to get your ship from the starting position to
the target position. If there is no route from the starting position to the target position, the line will be "NO ROUTE" instead.

A move can only be in one of the six basic directions: up, down, left, right, forward, back. Phrased more precisely, a move will either increment or decrement a single component of your current position vector by 1.

Sample Input

START 1
O
0 0 0
0 0 0
END
START 3
XXX
XXX
XXX
OOO
OOO
OOO
XXX
XXX
XXX
0 0 1
2 2 1
END
START 5
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
XXXXX
XXXXX
XXXXX
XXXXX
XXXXX
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
OOOOO
0 0 0
4 4 4
END

Sample Output

1 0
3 4
NO ROUTE

Source

South Central USA 2001

题意:一个三维的空间,从一个点到另一个点的最少步数。

题解;BFS模板,主要是要注意坐标的处理。

AC代码:

#include<iostream>
#include<string>
#include<cstring>
#include<queue>
#define N 15
using namespace std;
char chess[N][N][N];
string str;
int n,sx,sy,sz,ex,ey,ez,visit[N][N][N];
int dir[][3]={
    {0,0,1},{0,0,-1},{1,0,0},
    {-1,0,0},{0,1,0},{0,-1,0}
};
struct Node{
    int x,y,z,s;
};
bool ok(int x,int y,int z){
    if(x>=0&&x<n&&y>=0&&y<n&&z>=0&&z<n&&chess[x][y][z]=='O')
        return true;
    return false;
}
int bfs(){
    queue<Node> q;
    Node head={sx,sy,sz,0};
    q.push(head);
    memset(visit,-1,sizeof(visit));
    visit[sx][sy][sz]=0;
    while(q.size()){
        Node f=q.front();
        if(f.x==ex&&f.y==ey&&f.z==ez)return f.s;
        q.pop();
        for(int i=0;i<6;i++){
            int dx=f.x+dir[i][0],dy=f.y+dir[i][1],dz=f.z+dir[i][2];
            if(ok(dx,dy,dz)&&visit[dx][dy][dz]){
                visit[dx][dy][dz]=0;
                Node t={dx,dy,dz,f.s+1};
                q.push(t);
            }
        }
    }
    return -1;
}
int main()
{
        while(cin>>str>>n){
            for(int i=0;i<n;i++)
                for(int j=0;j<n;j++)
                    for(int k=0;k<n;k++)cin>>chess[k][j][i];
            cin>>sx>>sy>>sz>>ex>>ey>>ez;
            cin>>str;
            int tmp=bfs();
            if(tmp!=-1)cout<<n<<" "<<tmp<<endl;
            else cout<<"NO ROUTE"<<endl;
        }
        return 0;
}

【转载请注明出处】

作者:MummyDing

出处:http://blog.csdn.net/mummyding

时间: 2024-10-12 21:42:49

HDOJ 1240 Asteroids!的相关文章

hdu 1240:Asteroids!(三维BFS搜索)

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3159    Accepted Submission(s): 2106 Problem Description You're in space.You want to get home.There are asteroids.You don't want to hit

HDU 1240——Asteroids!(三维BFS)POJ 2225——Asteroids

普通的三维广搜,需要注意的是输入:列,行,层 #include<iostream> #include<cstdio> #include<cstring> #include<queue> #include<algorithm> #define M 11 using namespace std; int dir[6][3]={{0,1,0},{0,-1,0},{1,0,0},{-1,0,0},{0,0,1},{0,0,-1}};//6个方向 int

HDU 1240.Asteroids!

Asteroids! Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u SubmitStatusPracticeHDU 1240 Description You're in space. You want to get home. There are asteroids. You don't want to hit them. Input Input to this problem will

HDU 1240 Asteroids! (三维BFS)

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 4749    Accepted Submission(s): 3048 Problem Description You're in space. You want to get home. There are asteroids. You don't want to

HDU 1240 Asteroids!(BFS)

题目链接 Problem Description You're in space.You want to get home.There are asteroids.You don't want to hit them. Input Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the fo

BFS--- HDU 1240 Asteroids! 广度优先搜索

Asteroids! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 4038    Accepted Submission(s): 2605 Problem Description You're in space. You want to get home. There are asteroids. You don't want to

HDU 1240 Asteroids! 解题报告

//这道题做完我只有 三个感受  第一:坑: 第二 : 坑! 第三:还是坑! 咳咳  言归正传  WA了无数次之后才发现是输入进去时坐标时z, y, x的顺序输入的 题解   :  类似胜利大逃亡 只不过给你了起始坐标和终点坐标, 让你输出到达目标点所需最少步数: 输出时第一个输出时是START读入的map大小值n;第二个是所求步数 //细节: 1.读入:   读入时分别两次%S把没用的START 和 END读取掉: 2.输出时输出 三维坐标大小值n, 以及步数: 3.输入进去时开始点和结束点坐

HDU 1240 Asteroids!【BFS】

题意:给出一个三维的空间,给出起点和终点,问是否能够到达终点 和上一题一样,只不过这一题的坐标是zxy输入的, 因为题目中说的是接下来的n行中分别是由n*n的矩形组成的,所以第一个n该是Z坐标,n*n的矩形为底面,为x,y坐标 -----还是注意输入的方式--- #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> #include<queue> #de

BFS专题

题目编号 OJ编号 题目名称 题解链接 Problem A HDU 1548 A strange lift http://www.cnblogs.com/ohyee/p/5389459.html Problem B HDU 1372 Knight Moves http://www.cnblogs.com/ohyee/p/5389471.html Problem C HDU 2717 Catch That Cow http://www.cnblogs.com/ohyee/p/5389479.htm